/* ----------------------------------------------------------------------------
 *         ATMEL Microcontroller Software Support  -  ROUSSET  -
 * ----------------------------------------------------------------------------
 * Copyright (c) 2006, Atmel Corporation

 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the disclaiimer below.
 *
 * - Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the disclaimer below in the documentation and/or
 * other materials provided with the distribution.
 *
 * Atmel's name may not be used to endorse or promote products derived from
 * this software without specific prior written permission.
 *
 * DISCLAIMER: THIS SOFTWARE IS PROVIDED BY ATMEL "AS IS" AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT ARE
 * DISCLAIMED. IN NO EVENT SHALL ATMEL BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * ----------------------------------------------------------------------------
 */

/*
$Id: lun.h 198 2006-10-30 10:01:09Z jjoannic $
*/

#ifndef _LUN_H
#define _LUN_H

//------------------------------------------------------------------------------
//      Definitions
//------------------------------------------------------------------------------

#define LUN_STATUS_SUCCESS          0x00
#define LUN_STATUS_ERROR            0x02

//------------------------------------------------------------------------------
//      Structures
//------------------------------------------------------------------------------

// LUN structure
typedef struct {

    S_sbc_inquiry_data          *pInquiryData;
    unsigned char               *pReadWriteBuffer;
    S_sbc_request_sense_data    sRequestSenseData;
    S_sbc_read_capacity_10_data sReadCapacityData;
    S_media                     *pMedia;
    unsigned int                dBaseAddress;
    unsigned int                dSize;
    unsigned int                dBlockSize;

} S_lun;

//------------------------------------------------------------------------------
//      Exported functions
//------------------------------------------------------------------------------
extern void LUN_Init(S_lun         *pLun,
                     S_media       *pMedia,
                     unsigned char *pBuffer,
                     unsigned int  dBaseAddress,
                     unsigned int  dSize,
                     unsigned int  dBlockSize);

extern unsigned char LUN_Write(S_lun *pLun,
                               unsigned int dBlockAddress,
                               void         *pData,
                               unsigned int dLength,
                               Callback_f   fCallback,
                               void         *pArgument);

extern unsigned char LUN_Read(S_lun        *pLun,
                              unsigned int dBlockAddress,
                              void         *pData,
                              unsigned int dLength,
                              Callback_f   fCallback,
                              void         *pArgument);

#endif
